/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.105 Revision 1.407
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.105 2004/09/19 21:36:46 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.407 2012/10/11 16:50:53 mgorny Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12ECLASS=eutils 5# @ECLASS: eutils.eclass
13INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
14 17
15DEPEND="!bootstrap? ( sys-devel/patch )" 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
16 20
17DESCRIPTION="Based on the ${ECLASS} eclass" 21inherit multilib toolchain-funcs user
18 22
19# Wait for the supplied number of seconds. If no argument is supplied, defaults 23if has "${EAPI:-0}" 0 1 2; then
20# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 24
21# outputting to a terminal, don't wait. For compatability purposes, the argument 25# @FUNCTION: epause
22# must be an integer greater than zero. 26# @USAGE: [seconds]
23# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 27# @DESCRIPTION:
28# Sleep for the specified number of seconds (default of 5 seconds). Useful when
29# printing a message the user should probably be reading and often used in
30# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
31# don't wait at all. Defined in EAPIs 0 1 and 2.
24epause() { 32epause() {
25 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 33 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
26 sleep ${1:-5}
27 fi
28} 34}
29 35
30# Beep the specified number of times (defaults to five). If our output 36# @FUNCTION: ebeep
31# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 37# @USAGE: [number of beeps]
32# don't beep. 38# @DESCRIPTION:
33# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 39# Issue the specified number of beeps (default of 5 beeps). Useful when
40# printing a message the user should probably be reading and often used in
41# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
42# don't beep at all. Defined in EAPIs 0 1 and 2.
34ebeep() { 43ebeep() {
35 local n 44 local n
36 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 45 if [[ -z ${EBEEP_IGNORE} ]] ; then
37 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 46 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
38 echo -ne "\a" 47 echo -ne "\a"
39 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 48 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
40 echo -ne "\a" 49 echo -ne "\a"
41 sleep 1 50 sleep 1
42 done 51 done
43 fi 52 fi
44} 53}
45 54
46# This function simply returns the desired lib directory. With portage 55else
47# 2.0.51, we now have support for installing libraries to lib32/lib64 56
48# to accomidate the needs of multilib systems. It's no longer a good idea 57ebeep() {
49# to assume all libraries will end up in lib. Replace any (sane) instances 58 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
50# where lib is named directly with $(get_libdir) if possible. 59}
60
61epause() {
62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
63}
64
65fi
66
67# @FUNCTION: eqawarn
68# @USAGE: [message]
69# @DESCRIPTION:
70# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72# profile.
73if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
78fi
79
80# @FUNCTION: ecvs_clean
81# @USAGE: [list of dirs]
82# @DESCRIPTION:
83# Remove CVS directories recursiveley. Useful when a source tarball contains
84# internal CVS directories. Defaults to $PWD.
85ecvs_clean() {
86 [[ -z $* ]] && set -- .
87 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
88 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
89}
90
91# @FUNCTION: esvn_clean
92# @USAGE: [list of dirs]
93# @DESCRIPTION:
94# Remove .svn directories recursiveley. Useful when a source tarball contains
95# internal Subversion directories. Defaults to $PWD.
96esvn_clean() {
97 [[ -z $* ]] && set -- .
98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
99}
100
101# @FUNCTION: estack_push
102# @USAGE: <stack> [items to push]
103# @DESCRIPTION:
104# Push any number of items onto the specified stack. Pick a name that
105# is a valid variable (i.e. stick to alphanumerics), and push as many
106# items as you like onto the stack at once.
51# 107#
52# Travis Tilley <lv@gentoo.org> (24 Aug 2004) 108# The following code snippet will echo 5, then 4, then 3, then ...
53get_libdir() { 109# @CODE
54 LIBDIR_TEST=$(type econf) 110# estack_push mystack 1 2 3 4 5
55 if [ ! -z "${CONF_LIBDIR_OVERRIDE}" ] ; then 111# while estack_pop mystack i ; do
56 # if there is an override, we want to use that... always. 112# echo "${i}"
57 CONF_LIBDIR="${CONF_LIBDIR_OVERRIDE}" 113# done
58 # We don't need to know the verison of portage. We only need to know 114# @CODE
59 # if there is support for CONF_LIBDIR in econf and co. 115estack_push() {
60 # Danny van Dyk <kugelfang@gentoo.org> 2004/17/09 116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
61 #elif portageq has_version / '<sys-apps/portage-2.0.51_pre20' ; then 117 local stack_name="__ESTACK_$1__" ; shift
62 # # and if there isnt an override, and we're using a version of 118 eval ${stack_name}+=\( \"\$@\" \)
63 # # portage without CONF_LIBDIR support, force the use of lib. dolib 119}
64 # # and friends from portage 2.0.50 wont be too happy otherwise. 120
65 # CONF_LIBDIR="lib" 121# @FUNCTION: estack_pop
122# @USAGE: <stack> [variable]
123# @DESCRIPTION:
124# Pop a single item off the specified stack. If a variable is specified,
125# the popped item is stored there. If no more items are available, return
126# 1, else return 0. See estack_push for more info.
127estack_pop() {
128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129
130 # We use the fugly __estack_xxx var names to avoid collision with
131 # passing back the return value. If we used "local i" and the
132 # caller ran `estack_pop ... i`, we'd end up setting the local
133 # copy of "i" rather than the caller's copy. The __estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local __estack_name="__ESTACK_$1__" ; shift
137 local __estack_retvar=$1 ; shift
138 eval local __estack_i=\${#${__estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --__estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${__estack_retvar} ]] ; then
144 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
66 #fi 145 fi
67 elif [ "${LIBDIR_TEST/CONF_LIBDIR}" == "${LIBDIR_TEST}" ]; then # we don't have CONF_LIBDIR support 146 eval unset ${__estack_name}\[${__estack_i}\]
68 # will be <portage-2.0.51_pre20
69 CONF_LIBDIR="lib"
70 fi
71 # and of course, default to lib if CONF_LIBDIR isnt set
72 echo ${CONF_LIBDIR:=lib}
73 unset LIBDIR_TEST
74} 147}
75 148
76 149# @FUNCTION: eshopts_push
77get_multilibdir() { 150# @USAGE: [options to `set` or `shopt`]
78 echo ${CONF_MULTILIBDIR:=lib32} 151# @DESCRIPTION:
79} 152# Often times code will want to enable a shell option to change code behavior.
80 153# Since changing shell options can easily break other pieces of code (which
81 154# assume the default state), eshopts_push is used to (1) push the current shell
82# Sometimes you need to override the value returned by get_libdir. A good 155# options onto a stack and (2) pass the specified arguments to set.
83# example of this is xorg-x11, where lib32 isnt a supported configuration,
84# and where lib64 -must- be used on amd64 (for applications that need lib
85# to be 32bit, such as adobe acrobat). Note that this override also bypasses
86# portage version sanity checking.
87# get_libdir_override expects one argument, the result get_libdir should
88# return:
89# 156#
90# get_libdir_override lib64 157# If the first argument is '-s' or '-u', we assume you want to call `shopt`
158# rather than `set` as there are some options only available via that.
91# 159#
92# Travis Tilley <lv@gentoo.org> (31 Aug 2004) 160# A common example is to disable shell globbing so that special meaning/care
93get_libdir_override() { 161# may be used with variables/arguments to custom functions. That would be:
94 CONF_LIBDIR="$1" 162# @CODE
95 CONF_LIBDIR_OVERRIDE="$1" 163# eshopts_push -s noglob
96} 164# for x in ${foo} ; do
97 165# if ...some check... ; then
98# This function generate linker scripts in /usr/lib for dynamic 166# eshopts_pop
99# libs in /lib. This is to fix linking problems when you have
100# the .so in /lib, and the .a in /usr/lib. What happens is that
101# in some cases when linking dynamic, the .a in /usr/lib is used
102# instead of the .so in /lib due to gcc/libtool tweaking ld's
103# library search path. This cause many builds to fail.
104# See bug #4411 for more info.
105#
106# To use, simply call:
107#
108# gen_usr_ldscript libfoo.so
109#
110# Note that you should in general use the unversioned name of
111# the library, as ldconfig should usually update it correctly
112# to point to the latest version of the library present.
113#
114# <azarah@gentoo.org> (26 Oct 2002)
115#
116gen_usr_ldscript() {
117 # Just make sure it exists
118 dodir /usr/$(get_libdir)
119
120 cat > "${D}/usr/$(get_libdir)/$1" << END_LDSCRIPT
121/* GNU ld script
122 Because Gentoo have critical dynamic libraries
123 in /lib, and the static versions in /usr/lib, we
124 need to have a "fake" dynamic lib in /usr/lib,
125 otherwise we run into linking problems.
126 See bug #4411 on http://bugs.gentoo.org/ for
127 more info. */
128GROUP ( /$(get_libdir)/$1 )
129END_LDSCRIPT
130}
131
132# Simple function to draw a line consisting of '=' the same length as $*
133#
134# <azarah@gentoo.org> (11 Nov 2002)
135#
136draw_line() {
137 local i=0
138 local str_length=""
139
140 # Handle calls that do not have args, or wc not being installed ...
141 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
142 then
143 echo "==============================================================="
144 return 0 167# return 0
145 fi 168# fi
146
147 # Get the length of $*
148 str_length="$(echo -n "$*" | wc -m)"
149
150 while [ "$i" -lt "${str_length}" ]
151 do
152 echo -n "="
153
154 i=$((i + 1))
155 done 169# done
156 170# eshopts_pop
157 echo 171# @CODE
158 172eshopts_push() {
159 return 0 173 if [[ $1 == -[su] ]] ; then
174 estack_push eshopts "$(shopt -p)"
175 [[ $# -eq 0 ]] && return 0
176 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
177 else
178 estack_push eshopts $-
179 [[ $# -eq 0 ]] && return 0
180 set "$@" || die "${FUNCNAME}: bad options to set: $*"
181 fi
160} 182}
161 183
162# Default directory where patches are located 184# @FUNCTION: eshopts_pop
185# @USAGE:
186# @DESCRIPTION:
187# Restore the shell options to the state saved with the corresponding
188# eshopts_push call. See that function for more details.
189eshopts_pop() {
190 local s
191 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
192 if [[ ${s} == "shopt -"* ]] ; then
193 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
194 else
195 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
196 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
197 fi
198}
199
200# @FUNCTION: eumask_push
201# @USAGE: <new umask>
202# @DESCRIPTION:
203# Set the umask to the new value specified while saving the previous
204# value onto a stack. Useful for temporarily changing the umask.
205eumask_push() {
206 estack_push eumask "$(umask)"
207 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
208}
209
210# @FUNCTION: eumask_pop
211# @USAGE:
212# @DESCRIPTION:
213# Restore the previous umask state.
214eumask_pop() {
215 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
216 local s
217 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
218 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
219}
220
221# @VARIABLE: EPATCH_SOURCE
222# @DESCRIPTION:
223# Default directory to search for patches.
163EPATCH_SOURCE="${WORKDIR}/patch" 224EPATCH_SOURCE="${WORKDIR}/patch"
164# Default extension for patches 225# @VARIABLE: EPATCH_SUFFIX
226# @DESCRIPTION:
227# Default extension for patches (do not prefix the period yourself).
165EPATCH_SUFFIX="patch.bz2" 228EPATCH_SUFFIX="patch.bz2"
166# Default options for patch 229# @VARIABLE: EPATCH_OPTS
167# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 230# @DESCRIPTION:
231# Options to pass to patch. Meant for ebuild/package-specific tweaking
232# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
233# for single patch tweaking, you can also pass flags directly to epatch.
168EPATCH_OPTS="-g0" 234EPATCH_OPTS=""
235# @VARIABLE: EPATCH_COMMON_OPTS
236# @DESCRIPTION:
237# Common options to pass to `patch`. You probably should never need to
238# change these. If you do, please discuss it with base-system first to
239# be sure.
240# @CODE
241# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
242# --no-backup-if-mismatch - do not leave .orig files behind
243# -E - automatically remove empty files
244# @CODE
245EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
246# @VARIABLE: EPATCH_EXCLUDE
247# @DESCRIPTION:
169# List of patches not to apply. Not this is only file names, 248# List of patches not to apply. Note this is only file names,
170# and not the full path .. 249# and not the full path. Globs accepted.
171EPATCH_EXCLUDE="" 250EPATCH_EXCLUDE=""
251# @VARIABLE: EPATCH_SINGLE_MSG
252# @DESCRIPTION:
172# Change the printed message for a single patch. 253# Change the printed message for a single patch.
173EPATCH_SINGLE_MSG="" 254EPATCH_SINGLE_MSG=""
174# Force applying bulk patches even if not following the style: 255# @VARIABLE: EPATCH_MULTI_MSG
175# 256# @DESCRIPTION:
176# ??_${ARCH}_foo.${EPATCH_SUFFIX} 257# Change the printed message for multiple patches.
177# 258EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
259# @VARIABLE: EPATCH_FORCE
260# @DESCRIPTION:
261# Only require patches to match EPATCH_SUFFIX rather than the extended
262# arch naming style.
178EPATCH_FORCE="no" 263EPATCH_FORCE="no"
179 264
180# This function is for bulk patching, or in theory for just one 265# @FUNCTION: epatch
181# or two patches. 266# @USAGE: [options] [patches] [dirs of patches]
267# @DESCRIPTION:
268# epatch is designed to greatly simplify the application of patches. It can
269# process patch files directly, or directories of patches. The patches may be
270# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
271# the -p option as epatch will automatically attempt -p0 to -p5 until things
272# apply successfully.
182# 273#
183# It should work with .bz2, .gz, .zip and plain text patches. 274# If you do not specify any patches/dirs, then epatch will default to the
184# Currently all patches should be the same format. 275# directory specified by EPATCH_SOURCE.
185# 276#
186# You do not have to specify '-p' option to patch, as it will 277# Any options specified that start with a dash will be passed down to patch
187# try with -p0 to -p5 until it succeed, or fail at -p5. 278# for this specific invocation. As soon as an arg w/out a dash is found, then
279# arg processing stops.
188# 280#
189# Above EPATCH_* variables can be used to control various defaults, 281# When processing directories, epatch will apply all patches that match:
190# bug they should be left as is to ensure an ebuild can rely on 282# @CODE
191# them for. 283# if ${EPATCH_FORCE} != "yes"
192#
193# Patches are applied in current directory.
194#
195# Bulk Patches should preferibly have the form of:
196#
197# ??_${ARCH}_foo.${EPATCH_SUFFIX} 284# ??_${ARCH}_foo.${EPATCH_SUFFIX}
285# else
286# *.${EPATCH_SUFFIX}
287# @CODE
288# The leading ?? are typically numbers used to force consistent patch ordering.
289# The arch field is used to apply patches only for the host architecture with
290# the special value of "all" means apply for everyone. Note that using values
291# other than "all" is highly discouraged -- you should apply patches all the
292# time and let architecture details be detected at configure/compile time.
198# 293#
199# For example: 294# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
295# for patches to apply.
200# 296#
201# 01_all_misc-fix.patch.bz2 297# Refer to the other EPATCH_xxx variables for more customization of behavior.
202# 02_sparc_another-fix.patch.bz2
203#
204# This ensures that there are a set order, and you can have ARCH
205# specific patches.
206#
207# If you however give an argument to epatch(), it will treat it as a
208# single patch that need to be applied if its a file. If on the other
209# hand its a directory, it will set EPATCH_SOURCE to this.
210#
211# <azarah@gentoo.org> (10 Nov 2002)
212#
213epatch() { 298epatch() {
214 local PIPE_CMD="" 299 _epatch_draw_line() {
215 local STDERR_TARGET="${T}/$$.out" 300 # create a line of same length as input string
216 local PATCH_TARGET="${T}/$$.patch" 301 [[ -z $1 ]] && set "$(printf "%65s" '')"
217 local PATCH_SUFFIX="" 302 echo "${1//?/=}"
218 local SINGLE_PATCH="no" 303 }
219 local x=""
220 304
221 if [ "$#" -gt 1 ] 305 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
222 then 306
307 # First process options. We localize the EPATCH_OPTS setting
308 # from above so that we can pass it on in the loop below with
309 # any additional values the user has specified.
310 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
311 while [[ $# -gt 0 ]] ; do
312 case $1 in
313 -*) EPATCH_OPTS+=( "$1" ) ;;
314 *) break ;;
315 esac
316 shift
317 done
318
319 # Let the rest of the code process one user arg at a time --
320 # each arg may expand into multiple patches, and each arg may
321 # need to start off with the default global EPATCH_xxx values
322 if [[ $# -gt 1 ]] ; then
223 local m="" 323 local m
224 einfo "${#} patches to apply..."
225 for m in "$@" ; do 324 for m in "$@" ; do
226 epatch "${m}" 325 epatch "${m}"
227 done 326 done
228 return 0 327 return 0
229 fi 328 fi
230 329
231 if [ -n "$1" -a -f "$1" ] 330 local SINGLE_PATCH="no"
232 then 331 # no args means process ${EPATCH_SOURCE}
332 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
333
334 if [[ -f $1 ]] ; then
233 SINGLE_PATCH="yes" 335 SINGLE_PATCH="yes"
234 336 set -- "$1"
235 local EPATCH_SOURCE="$1" 337 # Use the suffix from the single patch (localize it); the code
338 # below will find the suffix for us
236 local EPATCH_SUFFIX="${1##*\.}" 339 local EPATCH_SUFFIX=$1
237 340
238 elif [ -n "$1" -a -d "$1" ] 341 elif [[ -d $1 ]] ; then
239 then 342 # Some people like to make dirs of patches w/out suffixes (vim)
240 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 343 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
241 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 344
345 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
346 # Re-use EPATCH_SOURCE as a search dir
347 epatch "${EPATCH_SOURCE}/$1"
348 return $?
349
350 else
351 # sanity check ... if it isn't a dir or file, wtf man ?
352 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
353 echo
354 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
355 eerror
356 eerror " ${EPATCH_SOURCE}"
357 eerror " ( ${EPATCH_SOURCE##*/} )"
358 echo
359 die "Cannot find \$EPATCH_SOURCE!"
360 fi
361
362 # Now that we know we're actually going to apply something, merge
363 # all of the patch options back in to a single variable for below.
364 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
365
366 local PIPE_CMD
367 case ${EPATCH_SUFFIX##*\.} in
368 xz) PIPE_CMD="xz -dc" ;;
369 lzma) PIPE_CMD="lzma -dc" ;;
370 bz2) PIPE_CMD="bzip2 -dc" ;;
371 gz|Z|z) PIPE_CMD="gzip -dc" ;;
372 ZIP|zip) PIPE_CMD="unzip -p" ;;
373 *) ;;
374 esac
375
376 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
377
378 local x
379 for x in "$@" ; do
380 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
381 # didn't match anything, ignore continue on
382 [[ ! -f ${x} ]] && continue
383
384 local patchname=${x##*/}
385
386 # Apply single patches, or forced sets of patches, or
387 # patches with ARCH dependant names.
388 # ???_arch_foo.patch
389 # Else, skip this input altogether
390 local a=${patchname#*_} # strip the ???_
391 a=${a%%_*} # strip the _foo.patch
392 if ! [[ ${SINGLE_PATCH} == "yes" || \
393 ${EPATCH_FORCE} == "yes" || \
394 ${a} == all || \
395 ${a} == ${ARCH} ]]
242 then 396 then
243 local EPATCH_SOURCE="$1/*" 397 continue
398 fi
399
400 # Let people filter things dynamically
401 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
402 # let people use globs in the exclude
403 eshopts_push -o noglob
404
405 local ex
406 for ex in ${EPATCH_EXCLUDE} ; do
407 if [[ ${patchname} == ${ex} ]] ; then
408 eshopts_pop
409 continue 2
410 fi
411 done
412
413 eshopts_pop
414 fi
415
416 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
417 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
418 einfo "${EPATCH_SINGLE_MSG}"
419 else
420 einfo "Applying ${patchname} ..."
421 fi
244 else 422 else
245 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 423 einfo " ${patchname} ..."
424 fi
425
426 # most of the time, there will only be one run per unique name,
427 # but if there are more, make sure we get unique log filenames
428 local STDERR_TARGET="${T}/${patchname}.out"
429 if [[ -e ${STDERR_TARGET} ]] ; then
430 STDERR_TARGET="${T}/${patchname}-$$.out"
431 fi
432
433 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
434
435 # Decompress the patch if need be
436 local count=0
437 local PATCH_TARGET
438 if [[ -n ${PIPE_CMD} ]] ; then
439 PATCH_TARGET="${T}/$$.patch"
440 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
441
442 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
443 echo
444 eerror "Could not extract patch!"
445 #die "Could not extract patch!"
446 count=5
447 break
246 fi 448 fi
449 else
450 PATCH_TARGET=${x}
451 fi
452
453 # Check for absolute paths in patches. If sandbox is disabled,
454 # people could (accidently) patch files in the root filesystem.
455 # Or trigger other unpleasantries #237667. So disallow -p0 on
456 # such patches.
457 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
458 if [[ -n ${abs_paths} ]] ; then
459 count=1
460 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
461 fi
462 # Similar reason, but with relative paths.
463 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
464 if [[ -n ${rel_paths} ]] ; then
465 eqawarn "QA Notice: Your patch uses relative paths '../'."
466 eqawarn " In the future this will cause a failure."
467 eqawarn "${rel_paths}"
468 fi
469
470 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
471 local patch_cmd
472 while [[ ${count} -lt 5 ]] ; do
473 patch_cmd="${BASH_ALIASES[patch]:-patch} -p${count} ${EPATCH_OPTS}"
474
475 # Generate some useful debug info ...
476 (
477 _epatch_draw_line "***** ${patchname} *****"
478 echo
479 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
480 echo
481 _epatch_draw_line "***** ${patchname} *****"
482 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
483 ret=$?
484 echo
485 echo "patch program exited with status ${ret}"
486 exit ${ret}
487 ) >> "${STDERR_TARGET}"
488
489 if [ $? -eq 0 ] ; then
490 (
491 _epatch_draw_line "***** ${patchname} *****"
492 echo
493 echo "ACTUALLY APPLYING ${patchname} ..."
494 echo
495 _epatch_draw_line "***** ${patchname} *****"
496 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
497 ret=$?
498 echo
499 echo "patch program exited with status ${ret}"
500 exit ${ret}
501 ) >> "${STDERR_TARGET}"
502
503 if [ $? -ne 0 ] ; then
504 echo
505 eerror "A dry-run of patch command succeeded, but actually"
506 eerror "applying the patch failed!"
507 #die "Real world sux compared to the dreamworld!"
508 count=5
509 fi
510 break
511 fi
512
513 : $(( count++ ))
514 done
515
516 # if we had to decompress the patch, delete the temp one
517 if [[ -n ${PIPE_CMD} ]] ; then
518 rm -f "${PATCH_TARGET}"
519 fi
520
521 if [[ ${count} -ge 5 ]] ; then
522 echo
523 eerror "Failed Patch: ${patchname} !"
524 eerror " ( ${PATCH_TARGET} )"
525 eerror
526 eerror "Include in your bugreport the contents of:"
527 eerror
528 eerror " ${STDERR_TARGET}"
529 echo
530 die "Failed Patch: ${patchname}!"
531 fi
532
533 # if everything worked, delete the full debug patch log
534 rm -f "${STDERR_TARGET}"
535
536 # then log away the exact stuff for people to review later
537 cat <<-EOF >> "${T}/epatch.log"
538 PATCH: ${x}
539 CMD: ${patch_cmd}
540 PWD: ${PWD}
541
542 EOF
543 eend 0
544 done
545
546 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
547 : # everything worked
548}
549
550# @FUNCTION: epatch_user
551# @USAGE:
552# @DESCRIPTION:
553# Applies user-provided patches to the source tree. The patches are
554# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>[:SLOT]/, where the first
555# of these three directories to exist will be the one to use, ignoring
556# any more general directories which might exist as well. They must end
557# in ".patch" to be applied.
558#
559# User patches are intended for quick testing of patches without ebuild
560# modifications, as well as for permanent customizations a user might
561# desire. Obviously, there can be no official support for arbitrarily
562# patched ebuilds. So whenever a build log in a bug report mentions that
563# user patches were applied, the user should be asked to reproduce the
564# problem without these.
565#
566# Not all ebuilds do call this function, so placing patches in the
567# stated directory might or might not work, depending on the package and
568# the eclasses it inherits and uses. It is safe to call the function
569# repeatedly, so it is always possible to add a call at the ebuild
570# level. The first call is the time when the patches will be
571# applied.
572#
573# Ideally, this function should be called after gentoo-specific patches
574# have been applied, so that their code can be modified as well, but
575# before calls to e.g. eautoreconf, as the user patches might affect
576# autotool input files as well.
577epatch_user() {
578 [[ $# -ne 0 ]] && die "epatch_user takes no options"
579
580 # Allow multiple calls to this function; ignore all but the first
581 local applied="${T}/epatch_user.log"
582 [[ -e ${applied} ]] && return 2
583
584 # don't clobber any EPATCH vars that the parent might want
585 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
586 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
587 EPATCH_SOURCE=${base}/${CTARGET}/${check}
588 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
589 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
590 if [[ -d ${EPATCH_SOURCE} ]] ; then
591 EPATCH_SOURCE=${EPATCH_SOURCE} \
592 EPATCH_SUFFIX="patch" \
593 EPATCH_FORCE="yes" \
594 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
595 epatch
596 echo "${EPATCH_SOURCE}" > "${applied}"
597 return 0
598 fi
599 done
600 echo "none" > "${applied}"
601 return 1
602}
603
604# @FUNCTION: emktemp
605# @USAGE: [temp dir]
606# @DESCRIPTION:
607# Cheap replacement for when debianutils (and thus mktemp)
608# does not exist on the users system.
609emktemp() {
610 local exe="touch"
611 [[ $1 == -d ]] && exe="mkdir" && shift
612 local topdir=$1
613
614 if [[ -z ${topdir} ]] ; then
615 [[ -z ${T} ]] \
616 && topdir="/tmp" \
617 || topdir=${T}
618 fi
619
620 if ! type -P mktemp > /dev/null ; then
621 # system lacks `mktemp` so we have to fake it
622 local tmp=/
623 while [[ -e ${tmp} ]] ; do
624 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
625 done
626 ${exe} "${tmp}" || ${exe} -p "${tmp}"
627 echo "${tmp}"
247 else 628 else
248 if [ ! -d ${EPATCH_SOURCE} ] 629 # the args here will give slightly wierd names on BSD,
249 then 630 # but should produce a usable file on all userlands
250 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 631 if [[ ${exe} == "touch" ]] ; then
251 then 632 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
252 EPATCH_SOURCE="$1" 633 else
634 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
635 fi
636 fi
637}
638
639# @FUNCTION: edos2unix
640# @USAGE: <file> [more files ...]
641# @DESCRIPTION:
642# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
643# to remove all of these text utilities from DEPEND variables because this
644# is a script based solution. Just give it a list of files to convert and
645# they will all be changed from the DOS CRLF format to the UNIX LF format.
646edos2unix() {
647 [[ $# -eq 0 ]] && return 0
648 sed -i 's/\r$//' -- "$@" || die
649}
650
651# @FUNCTION: make_desktop_entry
652# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
653# @DESCRIPTION:
654# Make a .desktop file.
655#
656# @CODE
657# binary: what command does the app run with ?
658# name: the name that will show up in the menu
659# icon: the icon to use in the menu entry
660# this can be relative (to /usr/share/pixmaps) or
661# a full path to an icon
662# type: what kind of application is this?
663# for categories:
664# http://standards.freedesktop.org/menu-spec/latest/apa.html
665# if unset, function tries to guess from package's category
666# fields: extra fields to append to the desktop file; a printf string
667# @CODE
668make_desktop_entry() {
669 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
670
671 local exec=${1}
672 local name=${2:-${PN}}
673 local icon=${3:-${PN}}
674 local type=${4}
675 local fields=${5}
676
677 if [[ -z ${type} ]] ; then
678 local catmaj=${CATEGORY%%-*}
679 local catmin=${CATEGORY##*-}
680 case ${catmaj} in
681 app)
682 case ${catmin} in
683 accessibility) type="Utility;Accessibility";;
684 admin) type=System;;
685 antivirus) type=System;;
686 arch) type="Utility;Archiving";;
687 backup) type="Utility;Archiving";;
688 cdr) type="AudioVideo;DiscBurning";;
689 dicts) type="Office;Dictionary";;
690 doc) type=Documentation;;
691 editors) type="Utility;TextEditor";;
692 emacs) type="Development;TextEditor";;
693 emulation) type="System;Emulator";;
694 laptop) type="Settings;HardwareSettings";;
695 office) type=Office;;
696 pda) type="Office;PDA";;
697 vim) type="Development;TextEditor";;
698 xemacs) type="Development;TextEditor";;
699 esac
700 ;;
701
702 dev)
703 type="Development"
704 ;;
705
706 games)
707 case ${catmin} in
708 action|fps) type=ActionGame;;
709 arcade) type=ArcadeGame;;
710 board) type=BoardGame;;
711 emulation) type=Emulator;;
712 kids) type=KidsGame;;
713 puzzle) type=LogicGame;;
714 roguelike) type=RolePlaying;;
715 rpg) type=RolePlaying;;
716 simulation) type=Simulation;;
717 sports) type=SportsGame;;
718 strategy) type=StrategyGame;;
719 esac
720 type="Game;${type}"
721 ;;
722
723 gnome)
724 type="Gnome;GTK"
725 ;;
726
727 kde)
728 type="KDE;Qt"
729 ;;
730
731 mail)
732 type="Network;Email"
733 ;;
734
735 media)
736 case ${catmin} in
737 gfx)
738 type=Graphics
739 ;;
740 *)
741 case ${catmin} in
742 radio) type=Tuner;;
743 sound) type=Audio;;
744 tv) type=TV;;
745 video) type=Video;;
746 esac
747 type="AudioVideo;${type}"
748 ;;
749 esac
750 ;;
751
752 net)
753 case ${catmin} in
754 dialup) type=Dialup;;
755 ftp) type=FileTransfer;;
756 im) type=InstantMessaging;;
757 irc) type=IRCClient;;
758 mail) type=Email;;
759 news) type=News;;
760 nntp) type=News;;
761 p2p) type=FileTransfer;;
762 voip) type=Telephony;;
763 esac
764 type="Network;${type}"
765 ;;
766
767 sci)
768 case ${catmin} in
769 astro*) type=Astronomy;;
770 bio*) type=Biology;;
771 calc*) type=Calculator;;
772 chem*) type=Chemistry;;
773 elec*) type=Electronics;;
774 geo*) type=Geology;;
775 math*) type=Math;;
776 physics) type=Physics;;
777 visual*) type=DataVisualization;;
778 esac
779 type="Education;Science;${type}"
780 ;;
781
782 sys)
783 type="System"
784 ;;
785
786 www)
787 case ${catmin} in
788 client) type=WebBrowser;;
789 esac
790 type="Network;${type}"
791 ;;
792
793 *)
794 type=
795 ;;
796 esac
797 fi
798 if [ "${SLOT}" == "0" ] ; then
799 local desktop_name="${PN}"
800 else
801 local desktop_name="${PN}-${SLOT}"
802 fi
803 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
804 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
805
806 # Don't append another ";" when a valid category value is provided.
807 type=${type%;}${type:+;}
808
809 eshopts_push -s extglob
810 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
811 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
812 ewarn "allowed in .desktop files if the value is not an absolute path."
813 icon=${icon%.@(xpm|png|svg)}
814 fi
815 eshopts_pop
816
817 cat <<-EOF > "${desktop}"
818 [Desktop Entry]
819 Name=${name}
820 Type=Application
821 Comment=${DESCRIPTION}
822 Exec=${exec}
823 TryExec=${exec%% *}
824 Icon=${icon}
825 Categories=${type}
826 EOF
827
828 if [[ ${fields:-=} != *=* ]] ; then
829 # 5th arg used to be value to Path=
830 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
831 fields="Path=${fields}"
832 fi
833 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
834
835 (
836 # wrap the env here so that the 'insinto' call
837 # doesn't corrupt the env of the caller
838 insinto /usr/share/applications
839 doins "${desktop}"
840 ) || die "installing desktop file failed"
841}
842
843# @FUNCTION: validate_desktop_entries
844# @USAGE: [directories]
845# @MAINTAINER:
846# Carsten Lohrke <carlo@gentoo.org>
847# @DESCRIPTION:
848# Validate desktop entries using desktop-file-utils
849validate_desktop_entries() {
850 if [[ -x /usr/bin/desktop-file-validate ]] ; then
851 einfo "Checking desktop entry validity"
852 local directories=""
853 for d in /usr/share/applications $@ ; do
854 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
855 done
856 if [[ -n ${directories} ]] ; then
857 for FILE in $(find ${directories} -name "*\.desktop" \
858 -not -path '*.hidden*' | sort -u 2>/dev/null)
859 do
860 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
861 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
862 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
863 done
864 fi
865 echo ""
866 else
867 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
868 fi
869}
870
871# @FUNCTION: make_session_desktop
872# @USAGE: <title> <command> [command args...]
873# @DESCRIPTION:
874# Make a GDM/KDM Session file. The title is the file to execute to start the
875# Window Manager. The command is the name of the Window Manager.
876#
877# You can set the name of the file via the ${wm} variable.
878make_session_desktop() {
879 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
880 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
881
882 local title=$1
883 local command=$2
884 local desktop=${T}/${wm:-${PN}}.desktop
885 shift 2
886
887 cat <<-EOF > "${desktop}"
888 [Desktop Entry]
889 Name=${title}
890 Comment=This session logs you into ${title}
891 Exec=${command} $*
892 TryExec=${command}
893 Type=XSession
894 EOF
895
896 (
897 # wrap the env here so that the 'insinto' call
898 # doesn't corrupt the env of the caller
899 insinto /usr/share/xsessions
900 doins "${desktop}"
901 )
902}
903
904# @FUNCTION: domenu
905# @USAGE: <menus>
906# @DESCRIPTION:
907# Install the list of .desktop menu files into the appropriate directory
908# (/usr/share/applications).
909domenu() {
910 (
911 # wrap the env here so that the 'insinto' call
912 # doesn't corrupt the env of the caller
913 local i j ret=0
914 insinto /usr/share/applications
915 for i in "$@" ; do
916 if [[ -f ${i} ]] ; then
917 doins "${i}"
918 ((ret+=$?))
919 elif [[ -d ${i} ]] ; then
920 for j in "${i}"/*.desktop ; do
921 doins "${j}"
922 ((ret+=$?))
923 done
924 else
925 ((++ret))
926 fi
927 done
928 exit ${ret}
929 )
930}
931
932# @FUNCTION: newmenu
933# @USAGE: <menu> <newname>
934# @DESCRIPTION:
935# Like all other new* functions, install the specified menu as newname.
936newmenu() {
937 (
938 # wrap the env here so that the 'insinto' call
939 # doesn't corrupt the env of the caller
940 insinto /usr/share/applications
941 newins "$@"
942 )
943}
944
945# @FUNCTION: _iconins
946# @INTERNAL
947# @DESCRIPTION:
948# function for use in doicon and newicon
949_iconins() {
950 (
951 # wrap the env here so that the 'insinto' call
952 # doesn't corrupt the env of the caller
953 local funcname=$1; shift
954 local size dir
955 local context=apps
956 local theme=hicolor
957
958 while [[ $# -gt 0 ]] ; do
959 case $1 in
960 -s|--size)
961 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
962 size=${2%%x*}
963 else
964 size=${2}
253 fi 965 fi
254 966 case ${size} in
255 echo 967 16|22|24|32|36|48|64|72|96|128|192|256)
256 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 968 size=${size}x${size};;
257 eerror 969 scalable)
258 eerror " ${EPATCH_SOURCE}"
259 echo
260 die "Cannot find \$EPATCH_SOURCE!"
261 fi
262
263 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
264 fi
265
266 case ${EPATCH_SUFFIX##*\.} in
267 bz2)
268 PIPE_CMD="bzip2 -dc"
269 PATCH_SUFFIX="bz2"
270 ;; 970 ;;
271 gz|Z|z) 971 *)
272 PIPE_CMD="gzip -dc" 972 eerror "${size} is an unsupported icon size!"
273 PATCH_SUFFIX="gz" 973 exit 1;;
274 ;; 974 esac
275 ZIP|zip) 975 shift 2;;
276 PIPE_CMD="unzip -p" 976 -t|--theme)
277 PATCH_SUFFIX="zip" 977 theme=${2}
278 ;; 978 shift 2;;
979 -c|--context)
980 context=${2}
981 shift 2;;
279 *) 982 *)
280 PIPE_CMD="cat" 983 if [[ -z ${size} ]] ; then
281 PATCH_SUFFIX="patch" 984 insinto /usr/share/pixmaps
282 ;; 985 else
283 esac 986 insinto /usr/share/icons/${theme}/${size}/${context}
284
285 if [ "${SINGLE_PATCH}" = "no" ]
286 then
287 einfo "Applying various patches (bugfixes/updates)..."
288 fi
289 for x in ${EPATCH_SOURCE}
290 do
291 # New ARCH dependant patch naming scheme...
292 #
293 # ???_arch_foo.patch
294 #
295 if [ -f ${x} ] && \
296 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] || \
297 [ "${EPATCH_FORCE}" = "yes" ])
298 then
299 local count=0
300 local popts="${EPATCH_OPTS}"
301
302 if [ -n "${EPATCH_EXCLUDE}" ]
303 then
304 if [ "`eval echo \$\{EPATCH_EXCLUDE/${x##*/}\}`" != "${EPATCH_EXCLUDE}" ]
305 then
306 continue
307 fi
308 fi 987 fi
309 988
310 if [ "${SINGLE_PATCH}" = "yes" ] 989 if [[ ${funcname} == doicon ]] ; then
311 then 990 if [[ -f $1 ]] ; then
312 if [ -n "${EPATCH_SINGLE_MSG}" ] 991 doins "${1}"
313 then 992 elif [[ -d $1 ]] ; then
314 einfo "${EPATCH_SINGLE_MSG}" 993 shopt -s nullglob
994 doins "${1}"/*.{png,svg}
995 shopt -u nullglob
315 else 996 else
316 einfo "Applying ${x##*/}..." 997 eerror "${1} is not a valid file/directory!"
998 exit 1
317 fi 999 fi
318 else 1000 else
319 einfo " ${x##*/}..." 1001 break
320 fi 1002 fi
321 1003 shift 1;;
322 echo "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1004 esac
323 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
324
325 # Allow for prefix to differ ... im lazy, so shoot me :/
326 while [ "${count}" -lt 5 ]
327 do
328 # Generate some useful debug info ...
329 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
330 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
331
332 if [ "${PATCH_SUFFIX}" != "patch" ]
333 then
334 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
335 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
336 else
337 PATCH_TARGET="${x}"
338 fi
339
340 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
341 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
342
343 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
344 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
345
346 if [ "${PATCH_SUFFIX}" != "patch" ]
347 then
348 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
349 then
350 echo
351 eerror "Could not extract patch!"
352 #die "Could not extract patch!"
353 count=5
354 break
355 fi
356 fi
357
358 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
359 then
360 draw_line "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
361 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
362 echo "ACTUALLY APPLYING ${x##*/}..." >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
363 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
364 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
365
366 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 2>&1
367
368 if [ "$?" -ne 0 ]
369 then
370 cat ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
371 echo
372 eerror "A dry-run of patch command succeeded, but actually"
373 eerror "applying the patch failed!"
374 #die "Real world sux compared to the dreamworld!"
375 count=5
376 fi
377
378 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
379
380 break
381 fi
382
383 count=$((count + 1))
384 done
385
386 if [ "${PATCH_SUFFIX}" != "patch" ]
387 then
388 rm -f ${PATCH_TARGET}
389 fi
390
391 if [ "${count}" -eq 5 ]
392 then
393 echo
394 eerror "Failed Patch: ${x##*/}!"
395 eerror
396 eerror "Include in your bugreport the contents of:"
397 eerror
398 eerror " ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}"
399 echo
400 die "Failed Patch: ${x##*/}!"
401 fi
402
403 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
404
405 eend 0
406 fi
407 done 1005 done
408 if [ "${SINGLE_PATCH}" = "no" ] 1006 if [[ ${funcname} == newicon ]] ; then
409 then 1007 newins "$@"
410 einfo "Done with patching"
411 fi
412}
413
414# This function return true if we are using the NPTL pthreads
415# implementation.
416#
417# <azarah@gentoo.org> (06 March 2003)
418#
419have_NPTL() {
420 cat > ${T}/test-nptl.c <<-"END"
421 #define _XOPEN_SOURCE
422 #include <unistd.h>
423 #include <stdio.h>
424
425 int main()
426 {
427 char buf[255];
428 char *str = buf;
429
430 confstr(_CS_GNU_LIBPTHREAD_VERSION, str, 255);
431 if (NULL != str) {
432 printf("%s\n", str);
433 if (NULL != strstr(str, "NPTL"))
434 return 0;
435 }
436
437 return 1;
438 }
439 END
440
441 einfon "Checking for _CS_GNU_LIBPTHREAD_VERSION support in glibc ... "
442 if gcc -o ${T}/nptl ${T}/test-nptl.c &> /dev/null
443 then
444 echo "yes"
445 einfon "Checking what PTHREADS implementation we have ... "
446 if ${T}/nptl
447 then
448 return 0
449 else
450 return 1
451 fi 1008 fi
452 else 1009 ) || die
453 echo "no"
454 fi
455
456 return 1
457} 1010}
458 1011
459# This function check how many cpu's are present, and then set 1012# @FUNCTION: doicon
460# -j in MAKEOPTS accordingly. 1013# @USAGE: [options] <icons>
1014# @DESCRIPTION:
1015# Install icon into the icon directory /usr/share/icons or into
1016# /usr/share/pixmaps if "--size" is not set.
1017# This is useful in conjunction with creating desktop/menu files.
461# 1018#
462# Thanks to nall <nall@gentoo.org> for this. 1019# @CODE
1020# options:
1021# -s, --size
1022# !!! must specify to install into /usr/share/icons/... !!!
1023# size of the icon, like 48 or 48x48
1024# supported icon sizes are:
1025# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1026# -c, --context
1027# defaults to "apps"
1028# -t, --theme
1029# defaults to "hicolor"
463# 1030#
464get_number_of_jobs() { 1031# icons: list of icons
465 local jobs=0
466
467 if [ ! -r /proc/cpuinfo ]
468 then
469 return 1
470 fi
471
472 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
473 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
474 then
475 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
476 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
477 ADMINPARAM="${ADMINPARAM/-j}"
478 fi
479
480 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
481
482 if [ "${ARCH}" = "amd64" -o "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
483 "${ARCH}" = "arm" -o "${ARCH}" = "mips" -o "${ARCH}" = "ia64" ]
484 then
485 # these archs will always have "[Pp]rocessor"
486 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
487
488 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
489 then
490 # sparc always has "ncpus active"
491 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
492
493 elif [ "${ARCH}" = "alpha" ]
494 then
495 # alpha has "cpus active", but only when compiled with SMP
496 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
497 then
498 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
499 else
500 jobs=2
501 fi
502
503 elif [ "${ARCH}" = "ppc" -o "${ARCH}" = "ppc64" ]
504 then
505 # ppc has "processor", but only when compiled with SMP
506 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ]
507 then
508 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
509 else
510 jobs=2
511 fi
512 elif [ "${ARCH}" = "s390" ]
513 then
514 # s390 has "# processors : "
515 jobs="$((`grep "^\# processors" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
516 else
517 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))"
518 die "Unknown ARCH -- ${ARCH}!"
519 fi
520
521 # Make sure the number is valid ...
522 if [ "${jobs}" -lt 1 ]
523 then
524 jobs=1
525 fi
526
527 if [ -n "${ADMINPARAM}" ]
528 then
529 if [ "${jobs}" -gt "${ADMINPARAM}" ]
530 then
531 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge..."
532 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
533 else
534 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge..."
535 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
536 fi
537 fi
538}
539
540# Cheap replacement for when debianutils (and thus mktemp)
541# does not exist on the users system
542# vapier@gentoo.org
543# 1032#
544# Takes just 1 parameter (the directory to create tmpfile in) 1033# example 1: doicon foobar.png fuqbar.svg suckbar.png
545mymktemp() { 1034# results in: insinto /usr/share/pixmaps
546 local topdir="$1" 1035# doins foobar.png fuqbar.svg suckbar.png
547
548 [ -z "${topdir}" ] && topdir=/tmp
549 if [ "`which mktemp 2>/dev/null`" ]
550 then
551 mktemp -p ${topdir}
552 else
553 local tmp="${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}"
554 touch ${tmp}
555 echo ${tmp}
556 fi
557}
558
559# Small wrapper for getent (Linux) and nidump (Mac OS X)
560# used in enewuser()/enewgroup()
561# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
562# 1036#
563# egetent(database, key) 1037# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
564egetent() { 1038# results in: insinto /usr/share/icons/hicolor/48x48/apps
565 if use macos || use ppc-macos ; then 1039# doins foobar.png fuqbar.png blobbar.png
566 case "$2" in 1040# @CODE
567 *[!0-9]*) # Non numeric 1041doicon() {
568 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 1042 _iconins ${FUNCNAME} "$@"
569 ;;
570 *) # Numeric
571 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
572 ;;
573 esac
574 else
575 getent $1 $2
576 fi
577} 1043}
578 1044
579# Simplify/standardize adding users to the system 1045# @FUNCTION: newicon
580# vapier@gentoo.org 1046# @USAGE: [options] <icon> <newname>
1047# @DESCRIPTION:
1048# Like doicon, install the specified icon as newname.
581# 1049#
582# enewuser(username, uid, shell, homedir, groups, extra options) 1050# @CODE
1051# example 1: newicon foobar.png NEWNAME.png
1052# results in: insinto /usr/share/pixmaps
1053# newins foobar.png NEWNAME.png
583# 1054#
584# Default values if you do not specify any: 1055# example 2: newicon -s 48 foobar.png NEWNAME.png
585# username: REQUIRED ! 1056# results in: insinto /usr/share/icons/hicolor/48x48/apps
586# uid: next available (see useradd(8)) 1057# newins foobar.png NEWNAME.png
587# note: pass -1 to get default behavior 1058# @CODE
588# shell: /bin/false 1059newicon() {
589# homedir: /dev/null 1060 _iconins ${FUNCNAME} "$@"
590# groups: none
591# extra: comment of 'added by portage for ${PN}'
592enewuser() {
593 # get the username
594 local euser="$1"; shift
595 if [ -z "${euser}" ]
596 then
597 eerror "No username specified !"
598 die "Cannot call enewuser without a username"
599 fi
600
601 # lets see if the username already exists
602 if [ "${euser}" == "`egetent passwd \"${euser}\" | cut -d: -f1`" ]
603 then
604 return 0
605 fi
606 einfo "Adding user '${euser}' to your system ..."
607
608 # options to pass to useradd
609 local opts=
610
611 # handle uid
612 local euid="$1"; shift
613 if [ ! -z "${euid}" ] && [ "${euid}" != "-1" ]
614 then
615 if [ "${euid}" -gt 0 ]
616 then
617 if [ ! -z "`egetent passwd ${euid}`" ]
618 then
619 euid="next"
620 fi
621 else
622 eerror "Userid given but is not greater than 0 !"
623 die "${euid} is not a valid UID"
624 fi
625 else
626 euid="next"
627 fi
628 if [ "${euid}" == "next" ]
629 then
630 local pwrange
631 if use macos || use ppc-macos ; then
632 pwrange="`jot 898 101`"
633 else
634 pwrange="`seq 101 999`"
635 fi
636 for euid in ${pwrange} ; do
637 [ -z "`egetent passwd ${euid}`" ] && break
638 done
639 fi
640 opts="${opts} -u ${euid}"
641 einfo " - Userid: ${euid}"
642
643 # handle shell
644 local eshell="$1"; shift
645 if [ ! -z "${eshell}" ] && [ "${eshell}" != "-1" ]
646 then
647 if [ ! -e "${eshell}" ]
648 then
649 eerror "A shell was specified but it does not exist !"
650 die "${eshell} does not exist"
651 fi
652 else
653 eshell="/bin/false"
654 fi
655 einfo " - Shell: ${eshell}"
656 opts="${opts} -s ${eshell}"
657
658 # handle homedir
659 local ehome="$1"; shift
660 if [ -z "${ehome}" ] && [ "${eshell}" != "-1" ]
661 then
662 ehome="/dev/null"
663 fi
664 einfo " - Home: ${ehome}"
665 opts="${opts} -d ${ehome}"
666
667 # handle groups
668 local egroups="$1"; shift
669 if [ ! -z "${egroups}" ]
670 then
671 local oldifs="${IFS}"
672 export IFS=","
673 for g in ${egroups}
674 do
675 if [ -z "`egetent group \"${g}\"`" ]
676 then
677 eerror "You must add group ${g} to the system first"
678 die "${g} is not a valid GID"
679 fi
680 done
681 export IFS="${oldifs}"
682 opts="${opts} -g ${egroups}"
683 else
684 egroups="(none)"
685 fi
686 einfo " - Groups: ${egroups}"
687
688 # handle extra and add the user
689 local eextra="$@"
690 local oldsandbox="${SANDBOX_ON}"
691 export SANDBOX_ON="0"
692 if use macos || use ppc-macos ;
693 then
694 ### Make the user
695 if [ -z "${eextra}" ]
696 then
697 dscl . create /users/${euser} uid ${euid}
698 dscl . create /users/${euser} shell ${eshell}
699 dscl . create /users/${euser} home ${ehome}
700 dscl . create /users/${euser} realname "added by portage for ${PN}"
701 ### Add the user to the groups specified
702 for g in ${egroups}
703 do
704 dscl . merge /groups/${g} users ${euser}
705 done
706 else
707 einfo "Extra options are not supported on macos yet"
708 einfo "Please report the ebuild along with the info below"
709 einfo "eextra: ${eextra}"
710 die "Required function missing"
711 fi
712 else
713 if [ -z "${eextra}" ]
714 then
715 useradd ${opts} ${euser} \
716 -c "added by portage for ${PN}" \
717 || die "enewuser failed"
718 else
719 einfo " - Extra: ${eextra}"
720 useradd ${opts} ${euser} ${eextra} \
721 || die "enewuser failed"
722 fi
723 fi
724 export SANDBOX_ON="${oldsandbox}"
725
726 if [ ! -e "${ehome}" ] && [ ! -e "${D}/${ehome}" ]
727 then
728 einfo " - Creating ${ehome} in ${D}"
729 dodir ${ehome}
730 fowners ${euser} ${ehome}
731 fperms 755 ${ehome}
732 fi
733} 1061}
734 1062
735# Simplify/standardize adding groups to the system 1063# @FUNCTION: strip-linguas
736# vapier@gentoo.org 1064# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
737# 1065# @DESCRIPTION:
738# enewgroup(group, gid)
739#
740# Default values if you do not specify any:
741# groupname: REQUIRED !
742# gid: next available (see groupadd(8))
743# extra: none
744enewgroup() {
745 # get the group
746 local egroup="$1"; shift
747 if [ -z "${egroup}" ]
748 then
749 eerror "No group specified !"
750 die "Cannot call enewgroup without a group"
751 fi
752
753 # see if group already exists
754 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
755 then
756 return 0
757 fi
758 einfo "Adding group '${egroup}' to your system ..."
759
760 # options to pass to useradd
761 local opts=
762
763 # handle gid
764 local egid="$1"; shift
765 if [ ! -z "${egid}" ]
766 then
767 if [ "${egid}" -gt 0 ]
768 then
769 if [ -z "`egetent group ${egid}`" ]
770 then
771 if use macos || use ppc-macos ; then
772 opts="${opts} ${egid}"
773 else
774 opts="${opts} -g ${egid}"
775 fi
776 else
777 egid="next available; requested gid taken"
778 fi
779 else
780 eerror "Groupid given but is not greater than 0 !"
781 die "${egid} is not a valid GID"
782 fi
783 else
784 egid="next available"
785 fi
786 einfo " - Groupid: ${egid}"
787
788 # handle extra
789 local eextra="$@"
790 opts="${opts} ${eextra}"
791
792 # add the group
793 local oldsandbox="${SANDBOX_ON}"
794 export SANDBOX_ON="0"
795 if use macos || use ppc-macos ;
796 then
797 if [ ! -z "${eextra}" ];
798 then
799 einfo "Extra options are not supported on macos yet"
800 einfo "Please report the ebuild along with the info below"
801 einfo "eextra: ${eextra}"
802 die "Required function missing"
803 fi
804
805 # If we need the next available
806 case ${egid} in
807 *[!0-9]*) # Non numeric
808 for egid in `jot 898 101`; do
809 [ -z "`egetent group ${egid}`" ] && break
810 done
811 esac
812 dscl . create /groups/${egroup} gid ${egid}
813 dscl . create /groups/${egroup} passwd '*'
814 else
815 groupadd ${opts} ${egroup} || die "enewgroup failed"
816 fi
817 export SANDBOX_ON="${oldsandbox}"
818}
819
820# Simple script to replace 'dos2unix' binaries
821# vapier@gentoo.org
822#
823# edos2unix(file, <more files>...)
824edos2unix() {
825 for f in "$@"
826 do
827 cp "${f}" ${T}/edos2unix
828 sed 's/\r$//' ${T}/edos2unix > "${f}"
829 done
830}
831
832# Make a desktop file !
833# Great for making those icons in kde/gnome startmenu !
834# Amaze your friends ! Get the women ! Join today !
835# gnome2 /usr/share/applications
836# gnome1 /usr/share/gnome/apps/
837# KDE ${KDEDIR}/share/applnk /usr/share/applnk
838#
839# make_desktop_entry(<binary>, [name], [icon], [type], [path])
840#
841# binary: what binary does the app run with ?
842# name: the name that will show up in the menu
843# icon: give your little like a pretty little icon ...
844# this can be relative (to /usr/share/pixmaps) or
845# a full path to an icon
846# type: what kind of application is this ? for categories:
847# http://www.freedesktop.org/standards/menu-spec/
848# path: if your app needs to startup in a specific dir
849make_desktop_entry() {
850 [ -z "$1" ] && eerror "You must specify the executable" && return 1
851
852 local exec="${1}"
853 local name="${2:-${PN}}"
854 local icon="${3:-${PN}.png}"
855 local type="${4}"
856 local subdir="${6}"
857 local path="${5:-${GAMES_BINDIR}}"
858 if [ -z "${type}" ]
859 then
860 case ${CATEGORY} in
861 "app-emulation")
862 type=Emulator
863 subdir="Emulation"
864 ;;
865 "games-"*)
866 type=Game
867 subdir="Games"
868 ;;
869 "net-"*)
870 type=Network
871 subdir="${type}"
872 ;;
873 *)
874 type=
875 subdir=
876 ;;
877 esac
878 fi
879 local desktop="${T}/${exec}.desktop"
880
881echo "[Desktop Entry]
882Encoding=UTF-8
883Version=0.9.2
884Name=${name}
885Type=Application
886Comment=${DESCRIPTION}
887Exec=${exec}
888Path=${path}
889Icon=${icon}
890Categories=Application;${type};" > "${desktop}"
891
892 if [ -d "/usr/share/applications" ]
893 then
894 insinto /usr/share/applications
895 doins "${desktop}"
896 fi
897
898 #if [ -d "/usr/share/gnome/apps" ]
899 #then
900 # insinto /usr/share/gnome/apps/Games
901 # doins ${desktop}
902 #fi
903
904 #if [ ! -z "`ls /usr/kde/* 2>/dev/null`" ]
905 #then
906 # for ver in /usr/kde/*
907 # do
908 # insinto ${ver}/share/applnk/Games
909 # doins ${desktop}
910 # done
911 #fi
912
913 if [ -d "/usr/share/applnk" ]
914 then
915 insinto /usr/share/applnk/${subdir}
916 doins "${desktop}"
917 fi
918
919 return 0
920}
921
922# for internal use only (unpack_pdv and unpack_makeself)
923find_unpackable_file() {
924 local src="$1"
925 if [ -z "${src}" ]
926 then
927 src="${DISTDIR}/${A}"
928 else
929 if [ -e "${DISTDIR}/${src}" ]
930 then
931 src="${DISTDIR}/${src}"
932 elif [ -e "${PWD}/${src}" ]
933 then
934 src="${PWD}/${src}"
935 elif [ -e "${src}" ]
936 then
937 src="${src}"
938 fi
939 fi
940 [ ! -e "${src}" ] && die "Could not find requested archive ${src}"
941 echo "${src}"
942}
943
944# Unpack those pesky pdv generated files ...
945# They're self-unpacking programs with the binary package stuffed in
946# the middle of the archive. Valve seems to use it a lot ... too bad
947# it seems to like to segfault a lot :(. So lets take it apart ourselves.
948#
949# Usage: unpack_pdv [file to unpack] [size of off_t]
950# - you have to specify the off_t size ... i have no idea how to extract that
951# information out of the binary executable myself. basically you pass in
952# the size of the off_t type (in bytes) on the machine that built the pdv
953# archive. one way to determine this is by running the following commands:
954# strings <pdv archive> | grep lseek
955# strace -elseek <pdv archive>
956# basically look for the first lseek command (we do the strings/grep because
957# sometimes the function call is _llseek or something) and steal the 2nd
958# parameter. here is an example:
959# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
960# lseek
961# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
962# lseek(3, -4, SEEK_END) = 2981250
963# thus we would pass in the value of '4' as the second parameter.
964unpack_pdv() {
965 local src="`find_unpackable_file $1`"
966 local sizeoff_t="$2"
967
968 [ -z "${sizeoff_t}" ] && die "No idea what off_t size was used for this pdv :("
969
970 local shrtsrc="`basename ${src}`"
971 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
972 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
973 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
974
975 # grab metadata for debug reasons
976 local metafile="`mymktemp ${T}`"
977 tail -c +$((${metaskip}+1)) ${src} > ${metafile}
978
979 # rip out the final file name from the metadata
980 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`"
981 datafile="`basename ${datafile}`"
982
983 # now lets uncompress/untar the file if need be
984 local tmpfile="`mymktemp ${T}`"
985 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
986
987 local iscompressed="`file -b ${tmpfile}`"
988 if [ "${iscompressed:0:8}" == "compress" ] ; then
989 iscompressed=1
990 mv ${tmpfile}{,.Z}
991 gunzip ${tmpfile}
992 else
993 iscompressed=0
994 fi
995 local istar="`file -b ${tmpfile}`"
996 if [ "${istar:0:9}" == "POSIX tar" ] ; then
997 istar=1
998 else
999 istar=0
1000 fi
1001
1002 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1003 #dd if=${src} ibs=${metaskip} count=1 \
1004 # | dd ibs=${tailskip} skip=1 \
1005 # | gzip -dc \
1006 # > ${datafile}
1007 if [ ${iscompressed} -eq 1 ] ; then
1008 if [ ${istar} -eq 1 ] ; then
1009 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1010 | head -c $((${metaskip}-${tailskip})) \
1011 | tar -xzf -
1012 else
1013 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1014 | head -c $((${metaskip}-${tailskip})) \
1015 | gzip -dc \
1016 > ${datafile}
1017 fi
1018 else
1019 if [ ${istar} -eq 1 ] ; then
1020 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1021 | head -c $((${metaskip}-${tailskip})) \
1022 | tar --no-same-owner -xf -
1023 else
1024 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1025 | head -c $((${metaskip}-${tailskip})) \
1026 > ${datafile}
1027 fi
1028 fi
1029 true
1030 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1031 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1032}
1033
1034# Unpack those pesky makeself generated files ...
1035# They're shell scripts with the binary package tagged onto
1036# the end of the archive. Loki utilized the format as does
1037# many other game companies.
1038#
1039# Usage: unpack_makeself [file to unpack] [offset]
1040# - If the file is not specified then unpack will utilize ${A}.
1041# - If the offset is not specified then we will attempt to extract
1042# the proper offset from the script itself.
1043unpack_makeself() {
1044 local src="`find_unpackable_file $1`"
1045 local skip="$2"
1046
1047 local shrtsrc="`basename ${src}`"
1048 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1049 if [ -z "${skip}" ]
1050 then
1051 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`"
1052 local skip=0
1053 case ${ver} in
1054 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1055 skip=`grep -a ^skip= ${src} | cut -d= -f2`
1056 ;;
1057 2.0|2.0.1)
1058 skip=`grep -a ^$'\t'tail ${src} | awk '{print $2}' | cut -b2-`
1059 ;;
1060 2.1.1)
1061 skip=`grep -a ^offset= ${src} | awk '{print $2}' | cut -b2-`
1062 let skip="skip + 1"
1063 ;;
1064 2.1.2)
1065 skip=`grep -a ^offset= ${src} | awk '{print $3}' | head -n 1`
1066 let skip="skip + 1"
1067 ;;
1068 2.1.3)
1069 skip=`grep -a ^offset= ${src} | awk '{print $3}'`
1070 let skip="skip + 1"
1071 ;;
1072 *)
1073 eerror "I'm sorry, but I was unable to support the Makeself file."
1074 eerror "The version I detected was '${ver}'."
1075 eerror "Please file a bug about the file ${shrtsrc} at"
1076 eerror "http://bugs.gentoo.org/ so that support can be added."
1077 die "makeself version '${ver}' not supported"
1078 ;;
1079 esac
1080 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1081 fi
1082
1083 # lets grab the first few bytes of the file to figure out what kind of archive it is
1084 local tmpfile="`mymktemp ${T}`"
1085 tail -n +${skip} ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1086 local filetype="`file -b ${tmpfile}`"
1087 case ${filetype} in
1088 *tar\ archive)
1089 tail -n +${skip} ${src} | tar --no-same-owner -xf -
1090 ;;
1091 bzip2*)
1092 tail -n +${skip} ${src} | bzip2 -dc | tar --no-same-owner -xf -
1093 ;;
1094 gzip*)
1095 tail -n +${skip} ${src} | tar --no-same-owner -xzf -
1096 ;;
1097 compress*)
1098 tail -n +${skip} ${src} | gunzip | tar --no-same-owner -xf -
1099 ;;
1100 *)
1101 eerror "Unknown filetype \"${filetype}\" ?"
1102 false
1103 ;;
1104 esac
1105 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1106}
1107
1108# Display a license for user to accept.
1109#
1110# Usage: check_license [license]
1111# - If the file is not specified then ${LICENSE} is used.
1112check_license() {
1113 local lic=$1
1114 if [ -z "${lic}" ] ; then
1115 lic="${PORTDIR}/licenses/${LICENSE}"
1116 else
1117 if [ -e "${PORTDIR}/licenses/${src}" ] ; then
1118 lic="${PORTDIR}/licenses/${src}"
1119 elif [ -e "${PWD}/${src}" ] ; then
1120 lic="${PWD}/${src}"
1121 elif [ -e "${src}" ] ; then
1122 lic="${src}"
1123 fi
1124 fi
1125 [ ! -f "${lic}" ] && die "Could not find requested license ${src}"
1126 local l="`basename ${lic}`"
1127
1128 # here is where we check for the licenses the user already
1129 # accepted ... if we don't find a match, we make the user accept
1130 local alic
1131 for alic in ${ACCEPT_LICENSE} ; do
1132 [ "${alic}" == "*" ] && return 0
1133 [ "${alic}" == "${l}" ] && return 0
1134 done
1135
1136 local licmsg="`mymktemp ${T}`"
1137 cat << EOF > ${licmsg}
1138**********************************************************
1139The following license outlines the terms of use of this
1140package. You MUST accept this license for installation to
1141continue. When you are done viewing, hit 'q'. If you
1142CTRL+C out of this, the install will not run!
1143**********************************************************
1144
1145EOF
1146 cat ${lic} >> ${licmsg}
1147 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1148 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1149 read alic
1150 case ${alic} in
1151 yes|Yes|y|Y)
1152 return 0
1153 ;;
1154 *)
1155 echo;echo;echo
1156 eerror "You MUST accept the license to continue! Exiting!"
1157 die "Failed to accept license"
1158 ;;
1159 esac
1160}
1161
1162# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1163# the whole 'non-interactive' policy, but damnit I want CD support !
1164#
1165# with these cdrom functions we handle all the user interaction and
1166# standardize everything. all you have to do is call cdrom_get_cds()
1167# and when the function returns, you can assume that the cd has been
1168# found at CDROM_ROOT.
1169#
1170# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1171# etc... if you want to give the cds better names, then just export
1172# the CDROM_NAME_X variables before calling cdrom_get_cds().
1173#
1174# for those multi cd ebuilds, see the cdrom_load_next_cd() below.
1175#
1176# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1177# - this will attempt to locate a cd based upon a file that is on
1178# the cd ... the more files you give this function, the more cds
1179# the cdrom functions will handle
1180cdrom_get_cds() {
1181 # first we figure out how many cds we're dealing with by
1182 # the # of files they gave us
1183 local cdcnt=0
1184 local f=
1185 for f in "$@" ; do
1186 cdcnt=$((cdcnt + 1))
1187 export CDROM_CHECK_${cdcnt}="$f"
1188 done
1189 export CDROM_TOTAL_CDS=${cdcnt}
1190 export CDROM_CURRENT_CD=1
1191
1192 # now we see if the user gave use CD_ROOT ...
1193 # if they did, let's just believe them that it's correct
1194 if [ ! -z "${CD_ROOT}" ] ; then
1195 export CDROM_ROOT="${CD_ROOT}"
1196 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1197 return
1198 fi
1199 # do the same for CD_ROOT_X
1200 if [ ! -z "${CD_ROOT_1}" ] ; then
1201 local var=
1202 cdcnt=0
1203 while [ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ] ; do
1204 cdcnt=$((cdcnt + 1))
1205 var="CD_ROOT_${cdcnt}"
1206 if [ -z "${!var}" ] ; then
1207 eerror "You must either use just the CD_ROOT"
1208 eerror "or specify ALL the CD_ROOT_X variables."
1209 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1210 die "could not locate CD_ROOT_${cdcnt}"
1211 fi
1212 export CDROM_ROOTS_${cdcnt}="${!var}"
1213 done
1214 export CDROM_ROOT=${CDROM_ROOTS_1}
1215 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1216 return
1217 fi
1218
1219 if [ ${CDROM_TOTAL_CDS} -eq 1 ] ; then
1220 einfon "This ebuild will need the "
1221 if [ -z "${CDROM_NAME}" ] ; then
1222 echo "cdrom for ${PN}."
1223 else
1224 echo "${CDROM_NAME}."
1225 fi
1226 echo
1227 einfo "If you do not have the CD, but have the data files"
1228 einfo "mounted somewhere on your filesystem, just export"
1229 einfo "the variable CD_ROOT so that it points to the"
1230 einfo "directory containing the files."
1231 echo
1232 else
1233 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1234 cdcnt=0
1235 while [ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ] ; do
1236 cdcnt=$((cdcnt + 1))
1237 var="CDROM_NAME_${cdcnt}"
1238 [ ! -z "${!var}" ] && einfo " CD ${cdcnt}: ${!var}"
1239 done
1240 echo
1241 einfo "If you do not have the CDs, but have the data files"
1242 einfo "mounted somewhere on your filesystem, just export"
1243 einfo "the following variables so they point to the right place:"
1244 einfon ""
1245 cdcnt=0
1246 while [ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ] ; do
1247 cdcnt=$((cdcnt + 1))
1248 echo -n " CD_ROOT_${cdcnt}"
1249 done
1250 echo
1251 einfo "Or, if you have all the files in the same place, or"
1252 einfo "you only have one cdrom, you can export CD_ROOT"
1253 einfo "and that place will be used as the same data source"
1254 einfo "for all the CDs."
1255 echo
1256 fi
1257 export CDROM_CURRENT_CD=0
1258 cdrom_load_next_cd
1259}
1260
1261# this is only used when you need access to more than one cd.
1262# when you have finished using the first cd, just call this function.
1263# when it returns, CDROM_ROOT will be pointing to the second cd.
1264# remember, you can only go forward in the cd chain, you can't go back.
1265cdrom_load_next_cd() {
1266 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1))
1267 local var=
1268
1269 if [ ! -z "${CD_ROOT}" ] ; then
1270 einfo "Using same root as before for CD #${CDROM_CURRENT_CD}"
1271 return
1272 fi
1273
1274 unset CDROM_ROOT
1275 var=CDROM_ROOTS_${CDROM_CURRENT_CD}
1276 if [ -z "${!var}" ] ; then
1277 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1278 cdrom_locate_file_on_cd ${!var}
1279 else
1280 export CDROM_ROOT="${!var}"
1281 fi
1282
1283 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1284}
1285
1286# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1287# functions. this should *never* be called from an ebuild.
1288# all it does is try to locate a give file on a cd ... if the cd isn't
1289# found, then a message asking for the user to insert the cdrom will be
1290# displayed and we'll hang out here until:
1291# (1) the file is found on a mounted cdrom
1292# (2) the user hits CTRL+C
1293cdrom_locate_file_on_cd() {
1294 while [ -z "${CDROM_ROOT}" ] ; do
1295 local dir="$(dirname ${@})"
1296 local file="$(basename ${@})"
1297 local mline=""
1298 local showedmsg=0
1299
1300 for mline in `mount | egrep -e '(iso|cdrom)' | awk '{print $3}'` ; do
1301 [ -d "${mline}/${dir}" ] || continue
1302 [ ! -z "$(find ${mline}/${dir} -iname ${file} -maxdepth 1)" ] \
1303 && export CDROM_ROOT=${mline}
1304 done
1305
1306 if [ -z "${CDROM_ROOT}" ] ; then
1307 echo
1308 if [ ${showedmsg} -eq 0 ] ; then
1309 if [ ${CDROM_TOTAL_CDS} -eq 1 ] ; then
1310 if [ -z "${CDROM_NAME}" ] ; then
1311 einfo "Please insert the cdrom for ${PN} now !"
1312 else
1313 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1314 fi
1315 else
1316 if [ -z "${CDROM_NAME_1}" ] ; then
1317 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1318 else
1319 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1320 einfo "Please insert+mount the ${!var} cdrom now !"
1321 fi
1322 fi
1323 showedmsg=1
1324 fi
1325 einfo "Press return to scan for the cd again"
1326 einfo "or hit CTRL+C to abort the emerge."
1327 read
1328 fi
1329 done
1330}
1331
1332# Make sure that LINGUAS only contains languages that 1066# Make sure that LINGUAS only contains languages that
1333# a package can support 1067# a package can support. The first form allows you to
1334# 1068# specify a list of LINGUAS. The -i builds a list of po
1335# usage: strip-linguas <allow LINGUAS> 1069# files found in all the directories and uses the
1336# strip-linguas -i <directories of .po files> 1070# intersection of the lists. The -u builds a list of po
1337# strip-linguas -u <directories of .po files> 1071# files found in all the directories and uses the union
1338# 1072# of the lists.
1339# The first form allows you to specify a list of LINGUAS.
1340# The -i builds a list of po files found in all the
1341# directories and uses the intersection of the lists.
1342# The -u builds a list of po files found in all the
1343# directories and uses the union of the lists.
1344strip-linguas() { 1073strip-linguas() {
1345 local ls newls 1074 local ls newls nols
1346 if [ "$1" == "-i" ] || [ "$1" == "-u" ] ; then 1075 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1347 local op="$1"; shift 1076 local op=$1; shift
1348 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1077 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1349 local d f 1078 local d f
1350 for d in "$@" ; do 1079 for d in "$@" ; do
1351 if [ "${op}" == "-u" ] ; then 1080 if [[ ${op} == "-u" ]] ; then
1352 newls="${ls}" 1081 newls=${ls}
1353 else 1082 else
1354 newls="" 1083 newls=""
1355 fi 1084 fi
1356 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1085 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1357 if [ "${op}" == "-i" ] ; then 1086 if [[ ${op} == "-i" ]] ; then
1358 [ "${ls/ ${f} /}" != "${ls}" ] && newls="${newls} ${f}" 1087 has ${f} ${ls} && newls="${newls} ${f}"
1359 else 1088 else
1360 [ "${ls/ ${f} /}" == "${ls}" ] && newls="${newls} ${f}" 1089 has ${f} ${ls} || newls="${newls} ${f}"
1361 fi 1090 fi
1362 done 1091 done
1363 ls="${newls}" 1092 ls=${newls}
1364 done 1093 done
1365 ls="${ls//.po}"
1366 else 1094 else
1367 ls="$@" 1095 ls="$@"
1368 fi 1096 fi
1369 1097
1370 ls=" ${ls} " 1098 nols=""
1371 newls="" 1099 newls=""
1372 for f in ${LINGUAS} ; do 1100 for f in ${LINGUAS} ; do
1373 if [ "${ls/ ${f} /}" != "${ls}" ] ; then 1101 if has ${f} ${ls} ; then
1374 nl="${newls} ${f}" 1102 newls="${newls} ${f}"
1375 else 1103 else
1376 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1104 nols="${nols} ${f}"
1377 fi 1105 fi
1378 done 1106 done
1107 [[ -n ${nols} ]] \
1108 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1109 export LINGUAS=${newls:1}
1110}
1111
1112# @FUNCTION: preserve_old_lib
1113# @USAGE: <libs to preserve> [more libs]
1114# @DESCRIPTION:
1115# These functions are useful when a lib in your package changes ABI SONAME.
1116# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1117# would break packages that link against it. Most people get around this
1118# by using the portage SLOT mechanism, but that is not always a relevant
1119# solution, so instead you can call this from pkg_preinst. See also the
1120# preserve_old_lib_notify function.
1121preserve_old_lib() {
1122 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1123 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1124 die "Invalid preserve_old_lib() usage"
1125 fi
1126 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1127
1128 # let portage worry about it
1129 has preserve-libs ${FEATURES} && return 0
1130
1131 local lib dir
1132 for lib in "$@" ; do
1133 [[ -e ${ROOT}/${lib} ]] || continue
1134 dir=${lib%/*}
1135 dodir ${dir} || die "dodir ${dir} failed"
1136 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1137 touch "${D}"/${lib}
1138 done
1139}
1140
1141# @FUNCTION: preserve_old_lib_notify
1142# @USAGE: <libs to notify> [more libs]
1143# @DESCRIPTION:
1144# Spit helpful messages about the libraries preserved by preserve_old_lib.
1145preserve_old_lib_notify() {
1146 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1147 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1148 die "Invalid preserve_old_lib_notify() usage"
1149 fi
1150
1151 # let portage worry about it
1152 has preserve-libs ${FEATURES} && return 0
1153
1154 local lib notice=0
1155 for lib in "$@" ; do
1156 [[ -e ${ROOT}/${lib} ]] || continue
1157 if [[ ${notice} -eq 0 ]] ; then
1158 notice=1
1159 ewarn "Old versions of installed libraries were detected on your system."
1160 ewarn "In order to avoid breaking packages that depend on these old libs,"
1161 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1162 ewarn "in order to remove these old dependencies. If you do not have this"
1163 ewarn "helper program, simply emerge the 'gentoolkit' package."
1164 ewarn
1165 fi
1166 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1167 done
1168}
1169
1170# @FUNCTION: built_with_use
1171# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1172# @DESCRIPTION:
1173#
1174# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1175#
1176# A temporary hack until portage properly supports DEPENDing on USE
1177# flags being enabled in packages. This will check to see if the specified
1178# DEPEND atom was built with the specified list of USE flags. The
1179# --missing option controls the behavior if called on a package that does
1180# not actually support the defined USE flags (aka listed in IUSE).
1181# The default is to abort (call die). The -a and -o flags control
1182# the requirements of the USE flags. They correspond to "and" and "or"
1183# logic. So the -a flag means all listed USE flags must be enabled
1184# while the -o flag means at least one of the listed IUSE flags must be
1185# enabled. The --hidden option is really for internal use only as it
1186# means the USE flag we're checking is hidden expanded, so it won't be found
1187# in IUSE like normal USE flags.
1188#
1189# Remember that this function isn't terribly intelligent so order of optional
1190# flags matter.
1191built_with_use() {
1192 local hidden="no"
1193 if [[ $1 == "--hidden" ]] ; then
1194 hidden="yes"
1195 shift
1196 fi
1197
1198 local missing_action="die"
1199 if [[ $1 == "--missing" ]] ; then
1200 missing_action=$2
1201 shift ; shift
1202 case ${missing_action} in
1203 true|false|die) ;;
1204 *) die "unknown action '${missing_action}'";;
1205 esac
1206 fi
1207
1208 local opt=$1
1209 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1210
1211 local PKG=$(best_version $1)
1212 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1213 shift
1214
1215 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1216 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1217
1218 # if the IUSE file doesn't exist, the read will error out, we need to handle
1219 # this gracefully
1220 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1221 case ${missing_action} in
1222 true) return 0;;
1223 false) return 1;;
1224 die) die "Unable to determine what USE flags $PKG was built with";;
1225 esac
1226 fi
1227
1228 if [[ ${hidden} == "no" ]] ; then
1229 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1230 # Don't check USE_EXPAND #147237
1231 local expand
1232 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1233 if [[ $1 == ${expand}_* ]] ; then
1234 expand=""
1235 break
1236 fi
1237 done
1238 if [[ -n ${expand} ]] ; then
1239 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1240 case ${missing_action} in
1241 true) return 0;;
1242 false) return 1;;
1243 die) die "$PKG does not actually support the $1 USE flag!";;
1244 esac
1245 fi
1246 fi
1247 fi
1248
1249 local USE_BUILT=$(<${USEFILE})
1250 while [[ $# -gt 0 ]] ; do
1251 if [[ ${opt} = "-o" ]] ; then
1252 has $1 ${USE_BUILT} && return 0
1253 else
1254 has $1 ${USE_BUILT} || return 1
1255 fi
1256 shift
1257 done
1258 [[ ${opt} = "-a" ]]
1259}
1260
1261# @FUNCTION: epunt_cxx
1262# @USAGE: [dir to scan]
1263# @DESCRIPTION:
1264# Many configure scripts wrongly bail when a C++ compiler could not be
1265# detected. If dir is not specified, then it defaults to ${S}.
1266#
1267# http://bugs.gentoo.org/73450
1268epunt_cxx() {
1269 local dir=$1
1270 [[ -z ${dir} ]] && dir=${S}
1271 ebegin "Removing useless C++ checks"
1272 local f
1273 find "${dir}" -name configure | while read f ; do
1274 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1275 done
1276 eend 0
1277}
1278
1279# @FUNCTION: make_wrapper
1280# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1281# @DESCRIPTION:
1282# Create a shell wrapper script named wrapper in installpath
1283# (defaults to the bindir) to execute target (default of wrapper) by
1284# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1285# libpaths followed by optionally changing directory to chdir.
1286make_wrapper() {
1287 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1288 local tmpwrapper=$(emktemp)
1289 # We don't want to quote ${bin} so that people can pass complex
1290 # things as $bin ... "./someprog --args"
1291 cat << EOF > "${tmpwrapper}"
1292#!/bin/sh
1293cd "${chdir:-.}"
1379 if [ -z "${newls}" ] ; then 1294if [ -n "${libdir}" ] ; then
1380 unset LINGUAS 1295 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1296 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1381 else 1297 else
1382 export LINGUAS="${newls}" 1298 export LD_LIBRARY_PATH="${libdir}"
1299 fi
1300fi
1301exec ${bin} "\$@"
1302EOF
1303 chmod go+rx "${tmpwrapper}"
1304 if [[ -n ${path} ]] ; then
1305 (
1306 exeinto "${path}"
1307 newexe "${tmpwrapper}" "${wrapper}"
1308 ) || die
1309 else
1310 newbin "${tmpwrapper}" "${wrapper}" || die
1311 fi
1312}
1313
1314# @FUNCTION: path_exists
1315# @USAGE: [-a|-o] <paths>
1316# @DESCRIPTION:
1317# Check if the specified paths exist. Works for all types of paths
1318# (files/dirs/etc...). The -a and -o flags control the requirements
1319# of the paths. They correspond to "and" and "or" logic. So the -a
1320# flag means all the paths must exist while the -o flag means at least
1321# one of the paths must exist. The default behavior is "and". If no
1322# paths are specified, then the return value is "false".
1323path_exists() {
1324 local opt=$1
1325 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1326
1327 # no paths -> return false
1328 # same behavior as: [[ -e "" ]]
1329 [[ $# -eq 0 ]] && return 1
1330
1331 local p r=0
1332 for p in "$@" ; do
1333 [[ -e ${p} ]]
1334 : $(( r += $? ))
1335 done
1336
1337 case ${opt} in
1338 -a) return $(( r != 0 )) ;;
1339 -o) return $(( r == $# )) ;;
1340 esac
1341}
1342
1343# @FUNCTION: in_iuse
1344# @USAGE: <flag>
1345# @DESCRIPTION:
1346# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1347# as necessary.
1348#
1349# Note that this function should not be used in the global scope.
1350in_iuse() {
1351 debug-print-function ${FUNCNAME} "${@}"
1352 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1353
1354 local flag=${1}
1355 local liuse=( ${IUSE} )
1356
1357 has "${flag}" "${liuse[@]#[+-]}"
1358}
1359
1360# @FUNCTION: use_if_iuse
1361# @USAGE: <flag>
1362# @DESCRIPTION:
1363# Return true if the given flag is in USE and IUSE.
1364#
1365# Note that this function should not be used in the global scope.
1366use_if_iuse() {
1367 in_iuse $1 || return 1
1368 use $1
1369}
1370
1371# @FUNCTION: usex
1372# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1373# @DESCRIPTION:
1374# Proxy to declare usex for package managers or EAPIs that do not provide it
1375# and use the package manager implementation when available (i.e. EAPI >= 5).
1376# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1377# otherwise echo [false output][false suffix] (defaults to "no").
1378if has "${EAPI:-0}" 0 1 2 3 4; then
1379 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1380fi
1381
1382# @FUNCTION: prune_libtool_files
1383# @USAGE: [--all]
1384# @DESCRIPTION:
1385# Locate unnecessary libtool files (.la) and libtool static archives
1386# (.a) and remove them from installation image.
1387#
1388# By default, .la files are removed whenever the static linkage can
1389# either be performed using pkg-config or doesn't introduce additional
1390# flags.
1391#
1392# If '--all' argument is passed, all .la files are removed. This is
1393# usually useful when the package installs plugins and does not use .la
1394# files for loading them.
1395#
1396# The .a files are only removed whenever corresponding .la files state
1397# that they should not be linked to, i.e. whenever these files
1398# correspond to plugins.
1399#
1400# Note: if your package installs both static libraries and .pc files,
1401# you need to add pkg-config to your DEPEND.
1402prune_libtool_files() {
1403 debug-print-function ${FUNCNAME} "$@"
1404
1405 local removing_all opt
1406 for opt; do
1407 case "${opt}" in
1408 --all)
1409 removing_all=1
1410 ;;
1411 *)
1412 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1413 esac
1414 done
1415
1416 local f
1417 local queue=()
1418 while IFS= read -r -d '' f; do # for all .la files
1419 local archivefile=${f/%.la/.a}
1420
1421 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1422
1423 # Remove static libs we're not supposed to link against.
1424 if grep -q '^shouldnotlink=yes$' "${f}"; then
1425 if [[ -f ${archivefile} ]]; then
1426 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1427 queue+=( "${archivefile}" )
1428 fi
1429
1430 # The .la file may be used by a module loader, so avoid removing it
1431 # unless explicitly requested.
1432 [[ ${removing_all} ]] || continue
1383 fi 1433 fi
1434
1435 # Remove .la files when:
1436 # - user explicitly wants us to remove all .la files,
1437 # - respective static archive doesn't exist,
1438 # - they are covered by a .pc file already,
1439 # - they don't provide any new information (no libs & no flags).
1440 local reason pkgconfig_scanned
1441 if [[ ${removing_all} ]]; then
1442 reason='requested'
1443 elif [[ ! -f ${archivefile} ]]; then
1444 reason='no static archive'
1445 elif [[ ! $(sed -nre \
1446 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1447 "${f}") ]]; then
1448 reason='no libs & flags'
1449 else
1450 if [[ ! ${pkgconfig_scanned} ]]; then
1451 # Create a list of all .pc-covered libs.
1452 local pc_libs=()
1453 if [[ ! ${removing_all} ]]; then
1454 local f
1455 local tf=${T}/prune-lt-files.pc
1456 local pkgconf=$(tc-getPKG_CONFIG)
1457
1458 while IFS= read -r -d '' f; do # for all .pc files
1459 local arg
1460
1461 sed -e '/^Requires:/d' "${f}" > "${tf}"
1462 for arg in $("${pkgconf}" --libs "${tf}"); do
1463 [[ ${arg} == -l* ]] && pc_libs+=( lib${arg#-l}.la )
1464 done
1465 done < <(find "${D}" -type f -name '*.pc' -print0)
1466
1467 rm -f "${tf}"
1468 fi
1469
1470 pkgconfig_scanned=1
1471 fi
1472
1473 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1474 fi
1475
1476 if [[ ${reason} ]]; then
1477 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1478 queue+=( "${f}" )
1479 fi
1480 done < <(find "${D}" -xtype f -name '*.la' -print0)
1481
1482 if [[ ${queue[@]} ]]; then
1483 rm -f "${queue[@]}"
1484 fi
1384} 1485}
1486
1487check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1488
1489fi

Legend:
Removed from v.1.105  
changed lines
  Added in v.1.407

  ViewVC Help
Powered by ViewVC 1.1.20